/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomEvent_H__
#define __GdomEvent_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomEvent GdomEvent;
typedef struct _GdomEventClass GdomEventClass;


#define GDOM_TYPE_EVENT            (gdom_event_get_type())
#define GDOM_EVENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_EVENT, GdomEvent))
#define GDOM_EVENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_EVENT, GdomEvent)Class)
#define GDOM_IS_EVENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_EVENT))
#define GDOM_IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_EVENT))
#define GDOM_EVENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_EVENT, GdomEventClass))

typedef struct _GdomEventPrivate GdomEventPrivate;

struct _GdomEvent {
    GdomDOMObject parent_instance;
    GdomEventPrivate *priv;
};

struct _GdomEventClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_event_get_type (void);

WEBKIT_API void
gdom_event_stop_propagation (GdomEvent *thiz);

WEBKIT_API void
gdom_event_prevent_default (GdomEvent *thiz);

WEBKIT_API void
gdom_event_init_event (GdomEvent *thiz, gchar * event_type_arg, gboolean can_bubble_arg, gboolean cancelable_arg);

G_END_DECLS

#endif /* __GdomEvent_H__ */
